//+------------------------------------------------------------------+
//|                                                 E_MA_5-10-20.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Hometrader"
// Modify         Vinin (vinin.ucoz.ru)
   
   extern int       TakeProfit =   2;
   extern int       Slippage   =   3;
   extern int       Limit      =   30;
   extern int       Contract   =   1;
   extern int        pos=1;
   
   double EMA_1_5;
   double EMA_1_10;
   double EMA_1_20;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
      Alert (" - init()  "); // 
   return;                                      //   init()
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Alert (" - deinit()  ");   // 
   return;                                      //   deinit()
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   int    m  =-1;
   int total;
   total  =   HistoryTotal();  //       
   if (total>0) {
      OrderSelect(total-1,SELECT_BY_POS,MODE_HISTORY);  //       
      m=OrderType();  //   
   }
   
   total = OrdersTotal(); 
   if (m==-1 && total >0) {
      OrderSelect(total-1,SELECT_BY_POS,MODE_TRADES);
      m=OrderType();  //   
   }

   //  if(m==0) Print("  BUY");
   //  if(m==1) Print("  SELL");
   //  if(m==-1) Print("  ");


   EMA_1_5  = iMA(NULL,1, 5, 0, MODE_EMA, 0,pos);
   EMA_1_10 = iMA(NULL,1,10, 0, MODE_EMA, 0,pos);
   EMA_1_20 = iMA(NULL,1,20, 0, MODE_EMA, 0,pos);

   if (m==-1) {
      if (EMA_1_5 > EMA_1_10 > EMA_1_20)
      {
         OrderSend(Symbol(),OP_BUY,0.1,Ask,3,0,0,NULL,0,0,CLR_NONE);
         Alert (GetLastError()); // 
      }
         // 
      if (EMA_1_20 > EMA_1_10 > EMA_1_5)  
      {
         OrderSend(Symbol(),OP_SELL,0.1,Bid,3,0,0,NULL,0,0,CLR_NONE);
      Alert (GetLastError());
      } 
   }
   if (total < Contract && m>=0) 
   {      //  
      if (EMA_1_5 > EMA_1_10 > EMA_1_20  && m==1)
      {
         OrderSend(Symbol(),OP_BUY,0.1,Ask,3,0,0,NULL,0,0,CLR_NONE);
         Alert (GetLastError()); // 
      }
         // 
      if (EMA_1_20 > EMA_1_10 > EMA_1_5 && m==0)  
      {
         OrderSend(Symbol(),OP_SELL,0.1,Bid,3,0,0,NULL,0,0,CLR_NONE);
         Alert (GetLastError());
    
      }
   }
   
   CloseAll(); //    
   return(0);
} 
//----------------------------------------------------------------------------- 
void CloseAll() 
{ 
  for (int cnt = OrdersTotal()-1 ; cnt >= 0; cnt--) 
  { 
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES); 
    if (OrderSymbol() == Symbol()) 
    { 
      if ((OrderProfit()>=TakeProfit)) 
      { 
        if(OrderType()==OP_BUY)  OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE); 
        if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE); 
      } 
      else 
      { 
        if((OrderType()==OP_BUY)  && (((OrderOpenPrice()-Ask)/Point) >= Limit))  //--
          OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE); 
        if((OrderType()==OP_SELL) && (((Bid-OrderOpenPrice())/Point) >= Limit))//---
          OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE); 
      } 
    } 
  } 
} 



